Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.beans
Class LibraryObject

    java.lang.Object
      oracle.ifs.beans.LibraryObject

All Implemented Interfaces:
  IfsEventHandler, LibraryObjectInterface, Traceable

Direct Known Subclasses:
  TieLibraryObject

    public abstract class LibraryObject

extends java.lang.Object
implements IfsEventHandler, LibraryObjectInterface

The LibraryObject class is the base class for all persistent Internet File System objects. Functionality common to all such classes is provided by this class.

(Published)

Field Summary
`static java.lang.String` | `DOMAIN_UNIQUENAME_DEFAULT_DELIMITER` Default String used in derived unique name values
`protected java.lang.Long` | `m_ClassId` The object Class ID.
`protected java.lang.Long` | `m_Id` The object ID.
`protected LibrarySession` | `m_Session` The session context for the object.
`static java.lang.String` | `NAME_ATTRIBUTE` Name of the attribute for the common name of an object.
`static java.lang.String` | `PROPERTYBUNDLE_ATTRIBUTE` Name of the attribute referencing the PropertyBundle for the object.

Constructor Summary
`protected` | `LibraryObject(LibrarySession session, java.lang.Long id, java.lang.Long classId, S_LibraryObjectData data)` Constructs an IFS object - standard variant.

Method Summary
`protected void` | `applyProperties(LibraryObjectDefinition def)` Applies any properties that might be present in the specified definition.
`protected void` | `auditCreated(LibraryObjectDefinition lodef)` Creates audit events for the create operation.
`protected void` | `auditUpdated(LibraryObjectDefinition lodef)` Creates audit events for the update operation.
`void` | `checkRequiredAttributeSet(LibraryObjectDefinition def, java.lang.String attrName, boolean forUpdate)` Verify that a required attribute is set properly in the specified LibraryObjectDefinition.
`void` | `clearCopyContext()` Remove the context of a copy operation for the target object.
`void` | `clearFreeContext()` Remove the context of a free operation for the target object.
`void` | `clearUpdateContext()` Remove the context of an update operation for the target object.
`static java.lang.Long[]` | `constructIdArray(LibraryObject[] objs)` Construct an array of object IDs from an array of LibraryObjects.
`protected static java.lang.Long[]` | `constructIdArray(java.util.Vector vector)` Construct an array of object IDs from a Vector of S_LibraryObjectData objects.
`protected static LibraryObject` | `constructLibraryObject(LibrarySession sess, S_LibraryObjectData data)`
`protected static java.util.Vector` | `constructLibraryObjectVector(LibrarySession sess, java.util.Vector vector)` Return LibraryObject Vector from a Vector of LibraryObject.
`protected PropertyBundle` | `createDedicatedPropertyBundle()` Creates a PropertyBundle for exclusive use by this instance.
`static java.lang.String` | `deriveDomainUniqueName(LibrarySession session, AttributeValue avName, AttributeValue avDomain, java.lang.String delim)` Derive a "Domain based unique name", which is a composite of an object which acts as an Domain for scoping purposes, and the object name.
`void` | `dispose()` Dispose this instance, by nulling the Id and Class Id.
`boolean` | `equals(LibraryObject item)` Compares whether two LibraryObjects are the same IFS object.
`void` | `free()` Permanently deletes this object.
`void` | `free(LibraryObjectDefinition def)` Permanently removes this object from the repository, with options.
`java.lang.Object` | `get(java.lang.String attr_name)` Returns an AttributeValue object that holds the value of the requested attribute.
`AttributeValue` | `getAttribute(java.lang.String attr_name)` Returns an AttributeValue object that holds the value of the requested attribute.
`AttributeValue` | `getAttributeByUpperCaseName(java.lang.String attr_name)` Returns the attribute value for the specified attribute.
`AttributeValue[]` | `getAttributes(java.lang.String[] attrNames)` Returns an array of AttributeValue objects that holds the values of the requested attributes.
`AttributeValue[]` | `getAttributesByUpperCaseNames(java.lang.String[] attrNames)` Returns an array of AttributeValue objects that holds the values of the requested attributes.
`Folder` | `getAuditDomainContext()` Gets the Domain context for auditing.
`Folder` | `getAuditEventFolderContext()` Gets the folder context to used for events posted on this event.
`java.lang.Long` | `getClassId()` Return this object's Class Id.
`java.lang.String` | `getClassname()` Returns the name of this object's class.
`java.lang.String` | `getClassName()` Returns the name of this object's class.
`ClassObject` | `getClassObject()` Returns this object's class.
`java.lang.String` | `getCommonName()` Returns the common Name of this object, or null of this object does not have a NAME attribute.
`LibraryObjectDefinition` | `getCopyContext()` Get the context of a copy operation, if a copy is in progress for the target object.
`LibraryObjectDefinition` | `getCreateContext()` Get the context of a create operation, if a create is in progress for the target object.
`protected S_LibraryObjectData` | `getData()` Gets the S_LibraryObjectData for this LibraryObject.
`LibraryObjectDefinition` | `getDefinition()` Creates a LibraryObjectDefinition which represents this object.
`java.util.Vector` | `getEffectivePolicyListElements(java.lang.String operation)` Gets the set of policies, as PolicyListElements, applied to this LibraryObject, either explicitly (through either its PolicyLists) or implicitly (through the ClassPolicyLists of its classobject hierarchy) for the specified operation.
`AttributeValue` | `getEventualAttributeByUpperCaseName(java.lang.String attrName, LibraryObjectDefinition def)` Gets the attribute value for the specified attribute from either the target object or from the specified definition.
`LibraryObjectDefinition` | `getFreeContext()` Get the context of a free operation, if a free is in progress for the target object.
`java.lang.Long` | `getId()` Returns this object's ID (as a Long).
`java.lang.String` | `getLabel()` Returns the Label for this object, based on the object's name.
`java.lang.String` | `getName()` Returns the Name of this object, or null of this object does not have a NAME attribute.
`ObjectReferenceAttributeValue` | `getObjectReferenceAttribute(java.lang.String attrname)` Gets the value of a ObjectReference attribute.
`protected OperationActionSpecification` | `getOperationActionSpecificationContext(AuditEvent event, Folder context)` Gets the OperationActionSpecification context (if any) for the event that is about to be posted.
`PropertyBundle` | `getPropertyBundle()` Returns this object's PropertyBundle.
`AttributeValue` | `getPropertyValue(java.lang.String key)` Returns a property from the PropertyBundle associated with this instance.
`PublicObject` | `getPublicObjectAttribute(java.lang.String attrName, java.lang.Long classId)` Gets a PublicObject type attribute from the target object.
`java.lang.String` | `getResourceString(java.lang.String key)` Gets the resource string for the specified key.
`java.lang.String` | `getResourceString(java.lang.String key, java.lang.Object[] params)` Gets the resource string for the specified key, and substitutes the specified parameters into that resource string.
`SchemaObject` | `getSchemaObjectAttribute(java.lang.String attrName, java.lang.Long classId)` Gets a SchemaObject type attribute from the target object.
`LibrarySession` | `getSession()` Returns the LibrarySession in which this object was instantiated.
`LibrarySessionInterface` | `getSessionInterface()` Gets the LibrarySessionInterface for this LibraryObject.
`S_LibraryObjectDataSharedStateFactory` | `getSharedStateFactory()` Returns a factory that can be used by bean-side callers to get shared state from a S_LibraryObjectData instance.
`java.lang.String` | `getStringIdentifier()` Returns this object's String ID.
`SystemObject` | `getSystemObjectAttribute(java.lang.String attrName, java.lang.Long classId)` Gets a SystemObject type attribute from the target object.
`TraceLogger` | `getTraceLogger()` Returns the trace logger of this object's session.
`LibraryObjectDefinition` | `getUpdateContext()` Get the context of an update operation, if an update is in progress for the target object.
`protected void` | `handleAdminModeChange()` Handles an intra-session admin mode change event.
`void` | `handleEvent(IfsEvent event)` Handles the specified event.
`protected void` | `handleFree(LibraryObjectDefinition def)` Handle the low-level repository free
`protected void` | `handleUpdate(LibraryObjectDefinition def)` Handle the low-level repository update
`int` | `hashCode()` Returns a hashcode value for the LibraryObject.
`boolean` | `hasNameAttribute()` Returns true if this object is an instance of a class that has a NAME attribute, and false otherwise.
`java.lang.Object` | `invokeOperation(OperationContext op)` Invokes a policy-driven operation.
`java.lang.Object` | `invokeOperation(java.lang.String operationName, LibraryObjectDefinition def)` Invokes a policy-driven operation.
`java.io.Serializable` | `invokeServerMethod(java.lang.String methodName, java.io.Serializable payload)` Invokes a custom server-side method.
`protected boolean` | `isConnected()` Indicates the connection state.
`protected boolean` | `isCoreEventPostingEnabled()` Checks if CORE audit event posting is enabled.
`boolean` | `isInstanceOf(ClassObject clss)` Determine if this is an instance of the specified ClassObject.
`boolean` | `isTraced(int channel, int level)` Gets whether tracing is enabled for the specified channel and level.
`protected boolean` | `isValidEventType(AuditEvent event)` Checks to see if the event type in the process of being posted on the target LibraryObject is consistent with the target.
`void` | `lockRows()` Obtain a low-level database lock on the rows of the tables used to represent this instnace.
`java.lang.String` | `lookupInstanceLabel()` Lookup the InstanceLabel for this object, and return null if no value is defined.
`protected void` | `postCreate(LibraryObjectDefinition def)` Extensibility point to perform actions after the creation of a object.
`void` | `postEvent(int eventType, int eventStatus)` Posts an event of the specified type and status.
`void` | `postEvent(int eventType, int eventSubtype, int eventStatus, long longPayload)` Posts an event of the specified type, subtype, and status.
`protected void` | `postFree(LibraryObjectDefinition def)` Extensibility point to perform actions after the permanent deletion ("Free") of a object.
`protected void` | `postUpdate(LibraryObjectDefinition def)` Extensibility point to perform actions after the update of a object.
`protected void` | `preCreate(LibraryObjectDefinition def)` Extensibility point to perform actions prior to the creation of a object.
`protected void` | `preFree(LibraryObjectDefinition def)` Extensibility point to perform actions prior to the permanent deletion ("free") of a object.
`protected void` | `prePostAuditEvent(AuditEvent event, int mode)` Extensibility point for creation of a new audit event.
`protected void` | `preUpdate(LibraryObjectDefinition def)` Extensibility point to perform actions prior to the update of a object.
`void` | `putProperty(AttributeValue av)` Adds a Property to this object's PropertyBundle.
`void` | `putProperty(java.lang.String name, AttributeValue av)` Adds a Property to this object's PropertyBundle.
`void` | `removeAllProperties()` Removes all Properties from this object's PropertyBundle, leaving an empty PropertyBundle.
`void` | `removeProperty(java.lang.String name)` Removes a Property from this object's PropertyBundle.
`RandomAccessContentInterface` | `renderAsRandomAccessContent(java.lang.String rendererType, java.lang.String rendererName, boolean writeable, java.util.Hashtable options)` Deprecated. CM SDK 10gR2: random access rendering is no longer supported
`java.io.Reader` | `renderAsReader(java.lang.String rendererType, java.lang.String rendererName, java.util.Hashtable options)` Renders this LibraryObject as a Reader.
`java.io.InputStream` | `renderAsStream(java.lang.String rendererType, java.lang.String rendererName, java.util.Hashtable options)` Renders this LibraryObject as an InputStream.
`void` | `setAttribute(AttributeValue attr_value)` Set this object's attribute to the specified value.
`void` | `setAttribute(java.lang.String attr_name, AttributeValue attr_value)` Set this object's attribute to the specified value.
`void` | `setAttributes(AttributeValue[] attrValues)` Set this object's attributes to the specified values.
`void` | `setAttributes(java.lang.String[] attrNames, AttributeValue[] values)` Set the values for a list of Attributes in the database.
`void` | `setCopyContext(LibraryObjectDefinition def)` Set the context of a copy operation for the target object.
`void` | `setFreeContext(LibraryObjectDefinition def)` Set the context of a free operation for the target object.
`protected void` | `setId(java.lang.Long id)` Sets this object's ID (as a Long).
`void` | `setName(java.lang.String name)` Set the Name of this object.
`void` | `setPropertyBundle(PropertyBundle bundle)` Sets this object's PropertyBundle.
`void` | `setPropertyValue(java.lang.String key, AttributeValue value)` Sets a property on the PropertyBundle associated with this instance.
`void` | `setUpdateContext(LibraryObjectDefinition def)` Set the context of an update operation for the target object.
`java.lang.String` | `toString()` Returns the Name of this object, or null of the object does not have a NAME attribute.
`void` | `trace(int channel, int level, java.lang.String payload)` Issues a trace request to the trace logger.
`protected boolean` | `trustHandleCreate()` Indicate whether low-level create should be trusted, and run with access checks disabled.
`protected boolean` | `trustHandleCreateAsAdmin()` Indicate whether low-level create should be trusted, and run with access checks disabled and in admin mode.
`protected boolean` | `trustHandleFree()` Indicate whether low-level free should be trusted, and run with access checks disabled.
`protected boolean` | `trustHandleFreeAsAdmin()` Indicate whether low-level free should be trusted, and run with access checks disabled and in admin mode.
`protected boolean` | `trustHandleUpdate()` Indicate whether low-level update should be trusted, and run with access checks disabled.
`protected boolean` | `trustHandleUpdateAsAdmin()` Indicate whether low-level update should be trusted in admin mode, and run with access checks disabled.
`void` | `update(LibraryObjectDefinition def)` Updates this object from the attributes and options set in the specified LibraryObjectDefinition.
`protected LibraryObjectDefinition` | `updateAndExposeDefinition(LibraryObjectDefinition def)` Updates this object from the attributes and options set in the specified LibraryObjectDefinition, returning the definition that was used server-side.
`protected void` | `validatePropertyValues(PropertyDefinition[] propDefs)` Validates Properties specified during create or update operations.
`protected static LibraryObject` | `vectorLibraryObjectElement(java.util.Vector vector, int index)`
`protected static LibraryObject[]` | `vectorToLibraryObjectArray(java.util.Vector vector)`
`protected void` | `verifyAdministrationMode()` Verifies the administration mode for the session.
`protected LibrarySession` | `verifyConnected()` Returns the current LibrarySession if the session is connected; otherwise raise a "not connected" exception.
`void` | `verifySystemUserAccess(LibrarySession session)` Verifies that the specified session hasnot discovered the target object illegally.
`protected void` | `verifyTargetObject()` Throw an exception if the object is not a valid persistent IFS object; e.g.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### DOMAIN_UNIQUENAME_DEFAULT_DELIMITER

    public static final java.lang.String DOMAIN_UNIQUENAME_DEFAULT_DELIMITER

  Description copied from class: `LibraryObject`
  Default String used in derived unique name values

  See Also:
    Constant Field Values
  (Published)

### NAME_ATTRIBUTE

    public static final java.lang.String NAME_ATTRIBUTE

  Description copied from class: `LibraryObject`
  Name of the attribute for the common name of an object.

  See Also:
    Constant Field Values
  (Unpublished)

### PROPERTYBUNDLE_ATTRIBUTE

    public static final java.lang.String PROPERTYBUNDLE_ATTRIBUTE

  Description copied from class: `LibraryObject`
  Name of the attribute referencing the PropertyBundle for the object.

  See Also:
    Constant Field Values
  (Unpublished)

### m_Session

    protected LibrarySession m_Session

  Description copied from class: `LibraryObject`
  The session context for the object.

  (Unpublished)

### m_Id

    protected java.lang.Long m_Id

  Description copied from class: `LibraryObject`
  The object ID.

  (Unpublished)

### m_ClassId

    protected java.lang.Long m_ClassId

  Description copied from class: `LibraryObject`
  The object Class ID.

  (Unpublished)

Constructor Detail

### LibraryObject

    protected LibraryObject(LibrarySession session,
                            java.lang.Long id,
                            java.lang.Long classId,
                            S_LibraryObjectData data)
                     throws IfsException

  Constructs an IFS object - standard variant.

  Parameters:
    `session` - the session
    `id` - the id
    `classId` - the class id
    `data` - the object's data
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

Method Detail

### setId

    protected void setId(java.lang.Long id)

  Description copied from class: `LibraryObject`
  Sets this object's ID (as a Long). Only allowed if the current ID is null.

  Parameters:
    `id` - the ID for this object
  (Unpublished)

### getData

    protected S_LibraryObjectData getData()
                                   throws IfsException

  Description copied from class: `LibraryObject`
  Gets the S_LibraryObjectData for this LibraryObject.

  Throws:
    `IfsException`
  (Unpublished)

### getName

    public java.lang.String getName()
                             throws IfsException

  Description copied from class: `LibraryObject`
  Returns the Name of this object, or null of this object does not have a NAME attribute.

  Returns:
    the name of this object.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### hasNameAttribute

    public boolean hasNameAttribute()
                             throws IfsException

  Description copied from class: `LibraryObject`
  Returns true if this object is an instance of a class that has a NAME attribute, and false otherwise.

  Returns:
    true if the object has a NAME attribute.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getCommonName

    public java.lang.String getCommonName()
                                   throws IfsException

  Description copied from class: `LibraryObject`
  Returns the common Name of this object, or null of this object does not have a NAME attribute.

  The common name can differ from the value returned from `getName` for classes whose name is made unique by combining it with other attributes.

  Returns:
    the common name of this object.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### deriveDomainUniqueName

    public static java.lang.String deriveDomainUniqueName(LibrarySession session,
                                                          AttributeValue avName,
                                                          AttributeValue avDomain,
                                                          java.lang.String delim)
                                                   throws IfsException

  Description copied from class: `LibraryObject`
  Derive a "Domain based unique name", which is a composite of an object which acts as an Domain for scoping purposes, and the object name.

  The form of the composite is [id][delim][name].
  The name is forced to uppercase.

  For example, for a Domain object with ID 1234 and an object name of "MyAdhocGroup", the derived unique name would be "1234-MYADHOCGROUP".

  If either of the specified attribute values are null or contain null values, the returned string is null.

  Parameters:
    `avName` - attribute value for the name
    `avDomain` - attribute value for the domain
    `delim` - the delimiter that separates the domain from the name
  Returns:
    the derived unique name, or null if either the name or domain attributes specified are null
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setPropertyBundle

    public void setPropertyBundle(PropertyBundle bundle)
                           throws IfsException

  Description copied from class: `LibraryObject`
  Sets this object's PropertyBundle.

  Parameters:
    `bundle` - the Properties setting.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getPropertyBundle

    public PropertyBundle getPropertyBundle()
                                     throws IfsException

  Description copied from class: `LibraryObject`
  Returns this object's PropertyBundle. Returns null if no PropertyBundle was specified.

  Returns:
    PropertyBundle for the object
  Throws:
    `IfsException` - if the operation fails
  (Published)

### putProperty

    public void putProperty(AttributeValue av)
                     throws IfsException

  Description copied from class: `LibraryObject`
  Adds a Property to this object's PropertyBundle. Creates a new PropertBundle if one does not already exist.

  Parameters:
    `av` - the name/value of the property to add
  Throws:
    `IfsException` - if the operation fails
  (Published)

### putProperty

    public void putProperty(java.lang.String name,
                            AttributeValue av)
                     throws IfsException

  Description copied from class: `LibraryObject`
  Adds a Property to this object's PropertyBundle. Creates a new PropertBundle if one does not already exist.

  Parameters:
    `name` - the name of the new property
    `av` - the value of the new property
  Throws:
    `IfsException` - if the operation fails
  (Published)

### removeProperty

    public void removeProperty(java.lang.String name)
                        throws IfsException

  Description copied from class: `LibraryObject`
  Removes a Property from this object's PropertyBundle.

  Parameters:
    `name` - the name of the property to remove
  Throws:
    `IfsException` - if the operation fails
  (Published)

### removeAllProperties

    public void removeAllProperties()
                             throws IfsException

  Description copied from class: `LibraryObject`
  Removes all Properties from this object's PropertyBundle, leaving an empty PropertyBundle.

  Throws:
    `IfsException` - if the operation fails
  (Published)

### getPropertyValue

    public AttributeValue getPropertyValue(java.lang.String key)
                                    throws IfsException

  Description copied from class: `LibraryObject`
  Returns a property from the PropertyBundle associated with this instance.

  Parameters:
    `key` - the property's key
  Returns:
    the property value, or null if no property exists with that key
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setPropertyValue

    public void setPropertyValue(java.lang.String key,
                                 AttributeValue value)
                          throws IfsException

  Description copied from class: `LibraryObject`
  Sets a property on the PropertyBundle associated with this instance.

  Parameters:
    `key` - the property's key
    `value` - the property value
  Throws:
    `IfsException` - if the operation fails
  (Published)

### createDedicatedPropertyBundle

    protected PropertyBundle createDedicatedPropertyBundle()
                                                    throws IfsException

  Description copied from class: `LibraryObject`
  Creates a PropertyBundle for exclusive use by this instance.

  Returns:
    a new PropertyBundle
  Throws:
    `IfsException` - if the operation fails
  (Published)

### applyProperties

    protected void applyProperties(LibraryObjectDefinition def)
                            throws IfsException

  Description copied from class: `LibraryObject`
  Applies any properties that might be present in the specified definition.

  This is called from both postCreate() and postUpdate().

  Parameters:
    `def` - The definition used in create or update operation
  Throws:
    `IfsException` - if the operation fails
  (Published)

### validatePropertyValues

    protected void validatePropertyValues(PropertyDefinition[] propDefs)
                                   throws IfsException

  Description copied from class: `LibraryObject`
  Validates Properties specified during create or update operations.

  Parameters:
    `propDefs` - The Property definitions
  Throws:
    `IfsException` -
    31601: if a name or value is not specified for a property
    other: if the operation otherwise fails
  (Published)

### getLabel

    public java.lang.String getLabel()
                              throws IfsException

  Description copied from class: `LibraryObject`
  Returns the Label for this object, based on the object's name. This is overridden by ClassObject and Attribute to return the ClassObjectLabel and AttributeLabel (respectively) strings from the Localizer, so that these names can be localized. For all other objects this method is invoked, which looks up the InstanceLabel in the Localizer and returns the localized value or simply the name if no localized label is defined.

  Returns:
    the label for this object.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### lookupInstanceLabel

    public java.lang.String lookupInstanceLabel()
                                         throws IfsException

  Description copied from class: `LibraryObject`
  Lookup the InstanceLabel for this object, and return null if no value is defined.

  Returns:
    the InstanceLabel for this object.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### toString

    public java.lang.String toString()

  Description copied from class: `LibraryObject`
  Returns the Name of this object, or null of the object does not have a NAME attribute.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    the name of this object.
  (Published)

### setName

    public void setName(java.lang.String name)
                 throws IfsException

  Description copied from class: `LibraryObject`
  Set the Name of this object. Does nothing if this object does not have a NAME attribute

  Parameters:
    `name` - the name of this object.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getAttribute

    public final AttributeValue getAttribute(java.lang.String attr_name)
                                      throws IfsException

  Description copied from class: `LibraryObject`
  Returns an AttributeValue object that holds the value of the requested attribute.

  Parameters:
    `attr_name` - the name of the Attribute
  Returns:
    the requested AttributeValue
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getAttributeByUpperCaseName

    public final AttributeValue getAttributeByUpperCaseName(java.lang.String attr_name)
                                                     throws IfsException

  Description copied from class: `LibraryObject`
  Returns the attribute value for the specified attribute. The attribute name must be UPPER CASE. This method is slightly faster as it does not automatically call `toUpperCase` on the attribute name.

  Specified by:
    `getAttributeByUpperCaseName` in interface `LibraryObjectInterface`
  Parameters:
    `attr_name` - the attribute name; must be all upper case
  Returns:
    the AttributeValue
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getEventualAttributeByUpperCaseName

    public AttributeValue getEventualAttributeByUpperCaseName(java.lang.String attrName,
                                                              LibraryObjectDefinition def)
                                                       throws IfsException

  Description copied from class: `LibraryObject`
  Gets the attribute value for the specified attribute from either the target object or from the specified definition.

  If the target object does not yet exist in the database (for example, during preCreate()), this will return the setting in the definition for this attribute, or null if this attribute is not set. If the target object does already exist, it will return the value set in the definition if specified, or the value on the existing object if not specified. This method also avoids the cost of forcing the specified attribute name to upper case by assuming that the caller is specifying an upper cased attribute name.

  Parameters:
    `attrName` - the attribute name; must be all upper case
    `def` - the definition
  Returns:
    the AttributeValue
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getObjectReferenceAttribute

    public ObjectReferenceAttributeValue getObjectReferenceAttribute(java.lang.String attrname)
                                                              throws IfsException

  Description copied from class: `LibraryObject`
  Gets the value of a ObjectReference attribute.

  Parameters:
    `attrname` - the attribute name
  Returns:
    the Serializable value
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### get

    public java.lang.Object get(java.lang.String attr_name)
                         throws IfsException,
                                java.lang.NoSuchMethodException

  Description copied from class: `LibraryObject`
  Returns an AttributeValue object that holds the value of the requested attribute.

  This is basically a cover to getAttribute(), that returns the actual data object associated with the requested AttributeValue.

  Parameters:
    `attr_name` - the name of the Attribute
  Returns:
    the object value (a String, Date, Boolean, etc.)
  Throws:
    `IfsException` - if operation fails.
    `java.lang.NoSuchMethodException` - if the passed attribute cannot be found.
  (Unpublished)

### getAttributes

    public AttributeValue[] getAttributes(java.lang.String[] attrNames)
                                   throws IfsException

  Description copied from class: `LibraryObject`
  Returns an array of AttributeValue objects that holds the values of the requested attributes.

  Parameters:
    `attrNames` - the names of the Attributes
  Returns:
    the requested array of AttributeValues
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getAttributesByUpperCaseNames

    public AttributeValue[] getAttributesByUpperCaseNames(java.lang.String[] attrNames)
                                                   throws IfsException

  Description copied from class: `LibraryObject`
  Returns an array of AttributeValue objects that holds the values of the requested attributes.

  Parameters:
    `attrNames` - the names of the Attributes; must be all upper case
  Returns:
    the requested array of AttributeValues
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getSystemObjectAttribute

    public SystemObject getSystemObjectAttribute(java.lang.String attrName,
                                                 java.lang.Long classId)
                                          throws IfsException

  Description copied from class: `LibraryObject`
  Gets a SystemObject type attribute from the target object.

  Parameters:
    `attrName` - the Attribute name (must be all uppercase).
    `classId` - the class Id for the attribute (may be null).
  Returns:
    the SystemObject, or null if the value of the attribute is null.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getSchemaObjectAttribute

    public SchemaObject getSchemaObjectAttribute(java.lang.String attrName,
                                                 java.lang.Long classId)
                                          throws IfsException

  Description copied from class: `LibraryObject`
  Gets a SchemaObject type attribute from the target object.

  Parameters:
    `attrName` - the Attribute name (must be all uppercase).
    `classId` - the class Id for the attribute (may be null).
  Returns:
    the SchemaObject, or null if the value of the attribute is null.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getPublicObjectAttribute

    public PublicObject getPublicObjectAttribute(java.lang.String attrName,
                                                 java.lang.Long classId)
                                          throws IfsException

  Description copied from class: `LibraryObject`
  Gets a PublicObject type attribute from the target object.

  Parameters:
    `attrName` - the Attribute name (must be all uppercase).
    `classId` - the class Id for the attribute (may be null).
  Returns:
    the PublicObject, or null if the value of the attribute is null.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### setAttribute

    public void setAttribute(java.lang.String attr_name,
                             AttributeValue attr_value)
                      throws IfsException

  Description copied from class: `LibraryObject`
  Set this object's attribute to the specified value. This variant will set the attribute's name in the AttributeValue to the name argument provided.

  Parameters:
    `attr_name` - the name of the Attribute
    `attr_value` - the desired value of the Attribute
  Throws:
    `IfsException` - if operation fails.
  (Published)

### setAttribute

    public void setAttribute(AttributeValue attr_value)
                      throws IfsException

  Description copied from class: `LibraryObject`
  Set this object's attribute to the specified value. The name of the attribute must have been set in the AttributeValue.

  Parameters:
    `attr_value` - the desired name & value of the Attribute
  Throws:
    `IfsException` - if operation fails.
  (Published)

### setAttributes

    public void setAttributes(java.lang.String[] attrNames,
                              AttributeValue[] values)
                       throws IfsException

  Description copied from class: `LibraryObject`
  Set the values for a list of Attributes in the database. Use this variant when your AttributeValues don't have their names set. You must provide the names in a separate String array.

  Parameters:
    `attrNames` - the names of the Attributes
    `values` - the desired values of the Attributes
  Throws:
    `IfsException` - if operation fails.
  (Published)

### setAttributes

    public void setAttributes(AttributeValue[] attrValues)
                       throws IfsException

  Description copied from class: `LibraryObject`
  Set this object's attributes to the specified values. Each AttributeValue must have its name set. This variant is slightly more efficient then the one that takes the attribute names in a seperate String array.

  Parameters:
    `attrValues` - the desired name & values of the Attributes
  Throws:
    `IfsException` - if operation fails.
  (Published)

### update

    public void update(LibraryObjectDefinition def)
                throws IfsException

  Description copied from class: `LibraryObject`
  Updates this object from the attributes and options set in the specified LibraryObjectDefinition.

  Parameters:
    `def` - the LibraryObjectDefinition describing the desired updates.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### updateAndExposeDefinition

    protected LibraryObjectDefinition updateAndExposeDefinition(LibraryObjectDefinition def)
                                                         throws IfsException

  Description copied from class: `LibraryObject`
  Updates this object from the attributes and options set in the specified LibraryObjectDefinition, returning the definition that was used server-side. This is needed in some cases to see side-effects that occured as part of the update.

  Parameters:
    `def` - the LibraryObjectDefinition describing the desired updates.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### handleUpdate

    protected void handleUpdate(LibraryObjectDefinition def)
                         throws IfsException

  Description copied from class: `LibraryObject`
  Handle the low-level repository update

  Parameters:
    `def` - the LibraryObjectDefinition describing the desired updates.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### trustHandleUpdate

    protected boolean trustHandleUpdate()

  Description copied from class: `LibraryObject`
  Indicate whether low-level update should be trusted, and run with access checks disabled.

  Returns:
    true if handleUpdate should be performed without access checks; false otherwise
  (Unpublished)

### trustHandleUpdateAsAdmin

    protected boolean trustHandleUpdateAsAdmin()

  Description copied from class: `LibraryObject`
  Indicate whether low-level update should be trusted in admin mode, and run with access checks disabled.

  Returns:
    true if handleUpdate should be performed without access checks and in admin mode; false otherwise
  (Unpublished)

### checkRequiredAttributeSet

    public void checkRequiredAttributeSet(LibraryObjectDefinition def,
                                          java.lang.String attrName,
                                          boolean forUpdate)
                                   throws IfsException

  Description copied from class: `LibraryObject`
  Verify that a required attribute is set properly in the specified LibraryObjectDefinition.

  Works for both create and update operations, which needs to be specified properly as an argument to this method. For create operations, the specified attribute must be specified and have a non-null value. For update operations, the specified attribute either need to be unspecified, or be specified with a non-null value.

  Throws 30012 if specified improperly.

  Parameters:
    `def` - the definition to be used in a create or update operation; cannot be null
    `attrName` - the attribute name; cannot be null
    `forUpdate` - whether the operation is an update operation
  Throws:
    `IfsException` - 30012 if the required attribute is not set properly
  (Unpublished)

### lockRows

    public void lockRows()
                  throws IfsException

  Description copied from class: `LibraryObject`
  Obtain a low-level database lock on the rows of the tables used to represent this instnace.

  This will use "select ... for update" to obtain row locks for each row used to identify this instance. To be effective, this method should be called within a bean-side transaction; otherwise the locks will be released when the method completes. The locks will be released when the outer most bean-side transaction commits or aborts.

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### invokeServerMethod

    public java.io.Serializable invokeServerMethod(java.lang.String methodName,
                                                   java.io.Serializable payload)
                                            throws IfsException

  Description copied from class: `LibraryObject`
  Invokes a custom server-side method. The payload and return are arbitrary Serializable objects. There must be a method with the specified name on the server-side Java class that maps to the target instance.

  Parameters:
    `methodName` - the method name.
    `payload` - the method argument
  Returns:
    the method result
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getEffectivePolicyListElements

    public java.util.Vector getEffectivePolicyListElements(java.lang.String operation)
                                                    throws IfsException

  Description copied from class: `LibraryObject`
  Gets the set of policies, as PolicyListElements, applied to this LibraryObject, either explicitly (through either its PolicyLists) or implicitly (through the ClassPolicyLists of its classobject hierarchy) for the specified operation.

  The PolicyListElements are returned in SORTSEQUENCE order. If more than one PolicyListElement has a particular SORTSEQUENCE value, a PolicyListElement introduced by the object's PolicyLists precedes a PolicyListElement introduced by a ClassPolicyList. If more than one PolicyListElement is introduced by a ClassPolicyList for a particular SORTSEQUENCE value, a PolicyListElement introduced by a classobject precedes the PolicyListElements introduced by the superclasses of that classobject. If more than one PolicyListElement is introduced by a object-level PolicyList for a particular SORTSEQUENCE value, the array ordering of the PolicyList objects in the PolicyLists attribute is used to determine precedence.

  Parameters:
    `operation` - the operation of interest, or null for all operations
  Returns:
    a Vector of PolicyListElement objects
  Throws:
    `IfsException` - if the operation fails
  (Published)

### invokeOperation

    public java.lang.Object invokeOperation(java.lang.String operationName,
                                            LibraryObjectDefinition def)
                                     throws IfsException

  Description copied from class: `LibraryObject`
  Invokes a policy-driven operation.

  The entire operation specification must currently be specified via a LibraryObjectDefinition.

  Parameters:
    `operationName` - the operation name
    `def` - the operation specification
  Returns:
    the operation result
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### invokeOperation

    public java.lang.Object invokeOperation(OperationContext op)
                                     throws IfsException

  Description copied from class: `LibraryObject`
  Invokes a policy-driven operation.

  The entire operation specification must currently be specified.

  Parameters:
    `op` - the operation specification
  Returns:
    the operation result
  Throws:
    `IfsException` - if operation fails.
  (Published)

### renderAsStream

    public java.io.InputStream renderAsStream(java.lang.String rendererType,
                                              java.lang.String rendererName,
                                              java.util.Hashtable options)
                                       throws IfsException

  Description copied from class: `LibraryObject`
  Renders this LibraryObject as an InputStream.

  The rendererType and rendererName together determine which Renderer implementation is to be used as follows:

  If rendererName is not null, the Policy named rendererName for the operation specified by rendererType is obtained. The fully-qualified classname of the Renderer is contained in the IMPLEMENTATION attribute of that Policy.

  If rendererName is null, the default Policy for this LibraryObject for the operation specified by rendererType is obtained. The fully- qualified classname of the Renderer is contained in the IMPLEMENTATION attribute of that Policy.

  The values in the options Hashtable must be serializable.

  Parameters:
    `rendererType` - the type of the desired Renderer
    `rendererName` - the name of the desired Renderer
    `options` - any Renderer-specific options
  Returns:
    the InputStream
  Throws:
    `IfsException` - (IFS-30110) if the operation fails
  (Unpublished)

### renderAsReader

    public java.io.Reader renderAsReader(java.lang.String rendererType,
                                         java.lang.String rendererName,
                                         java.util.Hashtable options)
                                  throws IfsException

  Description copied from class: `LibraryObject`
  Renders this LibraryObject as a Reader.

  The rendererType and rendererName together determine which Renderer implementation is to be used as follows:

  If rendererName is not null, the Policy named rendererName for the operation specified by rendererType is obtained. The fully-qualified classname of the Renderer is contained in the IMPLEMENTATION attribute of that Policy.

  If rendererName is null, the default Policy for this LibraryObject for the operation specified by rendererType is obtained. The fully- qualified classname of the Renderer is contained in the IMPLEMENTATION attribute of that Policy.

  The values in the options Hashtable must be serializable.

  Parameters:
    `rendererType` - the type of the desired Renderer
    `rendererName` - the name of the desired Renderer
    `options` - any Renderer-specific options
  Returns:
    the Reader
  Throws:
    `IfsException` - (IFS-30110) if the operation fails
  (Unpublished)

### renderAsRandomAccessContent

    public RandomAccessContentInterface renderAsRandomAccessContent(java.lang.String rendererType,
                                                                    java.lang.String rendererName,
                                                                    boolean writeable,
                                                                    java.util.Hashtable options)
                                                             throws IfsException

  Deprecated. CM SDK 10gR2: random access rendering is no longer supported

  Description copied from class: `LibraryObject`
  Renders this LibraryObject as a RandomAccessContent (RACI) object.

  The rendererType and rendererName together determine which Renderer implementation is to be used as follows:

  If rendererName is not null, the Policy named rendererName for the operation specified by rendererType is obtained. The fully-qualified classname of the Renderer is contained in the IMPLEMENTATION attribute of that Policy.

  If rendererName is null, the default Policy for this LibraryObject for the operation specified by rendererType is obtained. The fully- qualified classname of the Renderer is contained in the IMPLEMENTATION attribute of that Policy.

  The values in the options Hashtable must be serializable.

  Parameters:
    `rendererType` - the type of the desired Renderer
    `rendererName` - the name of the desired Renderer
    `writeable` - ignored; the returned RACI always non-writeable
    `options` - any Renderer-specific options
  Returns:
    the RandomAccessContent object
  Throws:
    `IfsException` - (IFS-30110) if the operation fails
  (Unpublished)

### getSession

    public LibrarySession getSession()
                              throws IfsException

  Description copied from class: `LibraryObject`
  Returns the LibrarySession in which this object was instantiated.

  Returns:
    the LibrarySession in which this object was instantiated.
  Throws:
    `IfsException`
  (Published)

### getSessionInterface

    public LibrarySessionInterface getSessionInterface()
                                                throws IfsException

  Description copied from class: `LibraryObject`
  Gets the LibrarySessionInterface for this LibraryObject.

  Specified by:
    `getSessionInterface` in interface `LibraryObjectInterface`
  Returns:
    the session interface
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### equals

    public boolean equals(LibraryObject item)
                   throws IfsException

  Description copied from class: `LibraryObject`
  Compares whether two LibraryObjects are the same IFS object. The comparison returns true only if the specified object is not null and only if both objects refer to an object that is not freed.

  Returns:
    true if the objects have the same Id.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### hashCode

    public int hashCode()

  Description copied from class: `LibraryObject`
  Returns a hashcode value for the LibraryObject.

  Overrides:
    `hashCode` in class `java.lang.Object`
  Returns:
    hashcode value
  (Published)

### dispose

    public void dispose()
                 throws IfsException

  Description copied from class: `LibraryObject`
  Dispose this instance, by nulling the Id and Class Id. This is called in reaction to notification that the underlying instance has been freed in the database.

  This method is public as it is invoked from BoundedLibraryObjectCache in the oracle.ifs.server.cache pacakge.

  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getClassname

    public java.lang.String getClassname()
                                  throws IfsException

  Description copied from class: `LibraryObject`
  Returns the name of this object's class.

  Returns:
    this object's class name
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### getClassName

    public java.lang.String getClassName()
                                  throws IfsException

  Description copied from class: `LibraryObject`
  Returns the name of this object's class.

  Returns:
    this object's class name (never returns null)
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getClassObject

    public ClassObject getClassObject()
                               throws IfsException

  Description copied from class: `LibraryObject`
  Returns this object's class.

  Returns:
    this object's class
  Throws:
    `IfsException` - if operation fails.
  (Published)

### free

    public void free()
              throws IfsException

  Description copied from class: `LibraryObject`
  Permanently deletes this object.

  Throws:
    `IfsException` - if operation fails.
  (Published)

### free

    public void free(LibraryObjectDefinition def)
              throws IfsException

  Description copied from class: `LibraryObject`
  Permanently removes this object from the repository, with options.

  Parameters:
    `def` - Context for the free operation. If null, a default definition is used.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### preCreate

    protected void preCreate(LibraryObjectDefinition def)
                      throws IfsException

  Description copied from class: `LibraryObject`
  Extensibility point to perform actions prior to the creation of a object.

  This method is typically overridden by subclasses that add attribute settings to the definition prior to the object being created, and/or create other objects that the target object depends on. At this point, the target object does not exist in the database, and therefore certain operations performed on the target will fail (such as `getAttribute`). Subclasses are expected to invoke `super.preCreate`.

  Parameters:
    `def` - object definition that will be used to create the object
  Throws:
    `IfsException` - if operation fails.
  (Published)

### postCreate

    protected void postCreate(LibraryObjectDefinition def)
                       throws IfsException

  Description copied from class: `LibraryObject`
  Extensibility point to perform actions after the creation of a object.

  This method is typically overridden by subclasses that perform operations after an object is created. Subclasses are expected to invoke `super.postCreate`.

  Parameters:
    `def` - object definition that was used to create the object
  Throws:
    `IfsException` - if operation fails.
  (Published)

### trustHandleCreate

    protected boolean trustHandleCreate()

  Description copied from class: `LibraryObject`
  Indicate whether low-level create should be trusted, and run with access checks disabled.

  Returns:
    true if handleCreate should be performed without access checks; false otherwise
  (Published)

### trustHandleCreateAsAdmin

    protected boolean trustHandleCreateAsAdmin()

  Description copied from class: `LibraryObject`
  Indicate whether low-level create should be trusted, and run with access checks disabled and in admin mode.

  Returns:
    true if handleCreate should be performed without access checks and in admin mode; false otherwise
  (Published)

### preFree

    protected void preFree(LibraryObjectDefinition def)
                    throws IfsException

  Description copied from class: `LibraryObject`
  Extensibility point to perform actions prior to the permanent deletion ("free") of a object.

  This method is typically overridden by subclasses that perform other operations prior to the target object being freed in order to all delete or modify objects related to the target object. Subclasses are expected to invoke `super.preFree`.

  Parameters:
    `def` - object definition used to hold options related to the free operation
  Throws:
    `IfsException` - if operation fails.
  (Published)

### handleFree

    protected void handleFree(LibraryObjectDefinition def)
                       throws IfsException

  Description copied from class: `LibraryObject`
  Handle the low-level repository free

  Parameters:
    `def` - the LibraryObjectDefinition describing the desired updates.
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### trustHandleFree

    protected boolean trustHandleFree()

  Description copied from class: `LibraryObject`
  Indicate whether low-level free should be trusted, and run with access checks disabled.

  Returns:
    true if handleFree should be performed without access checks; false otherwise
  (Published)

### trustHandleFreeAsAdmin

    protected boolean trustHandleFreeAsAdmin()

  Description copied from class: `LibraryObject`
  Indicate whether low-level free should be trusted, and run with access checks disabled and in admin mode.

  Returns:
    true if handleFree should be performed without access checks and in admin mode; false otherwise
  (Published)

### postFree

    protected void postFree(LibraryObjectDefinition def)
                     throws IfsException

  Description copied from class: `LibraryObject`
  Extensibility point to perform actions after the permanent deletion ("Free") of a object.

  This method is typically overridden by subclasses that perform operations after an object is freed. At this point, the target object no longer exists in the database, and therefore certain operations performed on the target will fail (such as `getAttribute`). Subclasses are expected to invoke `super.postFree`.

  Parameters:
    `def` - object definition used to hold options related to the free operation
  Throws:
    `IfsException` - if operation fails.
  (Published)

### preUpdate

    protected void preUpdate(LibraryObjectDefinition def)
                      throws IfsException

  Description copied from class: `LibraryObject`
  Extensibility point to perform actions prior to the update of a object.

  This method is typically overridden by subclasses that perform other operations prior to the target object being updated, in order to modify objects related to the target object. Subclasses are expected to invoke `super.preUpdate`.

  Parameters:
    `def` - object definition used to define how the target object will be updated
  Throws:
    `IfsException` - if operation fails.
  (Published)

### postUpdate

    protected void postUpdate(LibraryObjectDefinition def)
                       throws IfsException

  Description copied from class: `LibraryObject`
  Extensibility point to perform actions after the update of a object.

  This method is typically overridden by subclasses that perform other operations after the target object has being updated, in order to modify objects related to the target object. Subclasses are expected to invoke `super.postUpdate`.

  Parameters:
    `def` - object definition used to define how the target object was updated
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getCreateContext

    public final LibraryObjectDefinition getCreateContext()
                                                   throws IfsException

  Description copied from class: `LibraryObject`
  Get the context of a create operation, if a create is in progress for the target object.

  Will return true only when called during postCreate() of the target object.

  Returns:
    the create operation context if the target object has a create operation in progress, or null otherwise
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### setFreeContext

    public final void setFreeContext(LibraryObjectDefinition def)
                              throws IfsException

  Description copied from class: `LibraryObject`
  Set the context of a free operation for the target object.

  Parameters:
    `def` - the free operation context
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getFreeContext

    public final LibraryObjectDefinition getFreeContext()
                                                 throws IfsException

  Description copied from class: `LibraryObject`
  Get the context of a free operation, if a free is in progress for the target object.

  Returns:
    the free operation context if the target object has a free operation in progress, or null otherwise
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### clearFreeContext

    public final void clearFreeContext()
                                throws IfsException

  Description copied from class: `LibraryObject`
  Remove the context of a free operation for the target object.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### setUpdateContext

    public final void setUpdateContext(LibraryObjectDefinition def)
                                throws IfsException

  Description copied from class: `LibraryObject`
  Set the context of an update operation for the target object.

  Parameters:
    `def` - the update operation context
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getUpdateContext

    public final LibraryObjectDefinition getUpdateContext()
                                                   throws IfsException

  Description copied from class: `LibraryObject`
  Get the context of an update operation, if an update is in progress for the target object.

  Returns:
    the update operation context if the target object has an update operation in progress, or null otherwise
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### clearUpdateContext

    public final void clearUpdateContext()
                                  throws IfsException

  Description copied from class: `LibraryObject`
  Remove the context of an update operation for the target object.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### setCopyContext

    public final void setCopyContext(LibraryObjectDefinition def)
                              throws IfsException

  Description copied from class: `LibraryObject`
  Set the context of a copy operation for the target object.

  Parameters:
    `def` - the copy operation context
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getCopyContext

    public final LibraryObjectDefinition getCopyContext()
                                                 throws IfsException

  Description copied from class: `LibraryObject`
  Get the context of a copy operation, if a copy is in progress for the target object.

  Returns:
    the copy operation context if the target object has a copy operation in progress, or null otherwise
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### clearCopyContext

    public final void clearCopyContext()
                                throws IfsException

  Description copied from class: `LibraryObject`
  Remove the context of a copy operation for the target object.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getAuditDomainContext

    public Folder getAuditDomainContext()
                                 throws IfsException

  Description copied from class: `LibraryObject`
  Gets the Domain context for auditing.

  Returns:
    the domain context
  Throws:
    `IfsException` - if the operation fails

### getAuditEventFolderContext

    public Folder getAuditEventFolderContext()
                                      throws IfsException

  Description copied from class: `LibraryObject`
  Gets the folder context to used for events posted on this event.

  Returns:
    the folder context for the target
  Throws:
    `IfsException` - if the operation fails

### getOperationActionSpecificationContext

    protected OperationActionSpecification getOperationActionSpecificationContext(AuditEvent event,
                                                                                  Folder context)
                                                                           throws IfsException

  Description copied from class: `LibraryObject`
  Gets the OperationActionSpecification context (if any) for the event that is about to be posted.

  Parameters:
    `event` - the event
    `context` - the folder context
  Throws:
    `IfsException` - if the operation fails

### prePostAuditEvent

    protected void prePostAuditEvent(AuditEvent event,
                                     int mode)
                              throws IfsException

  Description copied from class: `LibraryObject`
  Extensibility point for creation of a new audit event.

  Parameters:
    `event` - the event to post
    `mode` - the success/fail mode for the post
  Throws:
    `IfsException` - if the operation fails

### isCoreEventPostingEnabled

    protected boolean isCoreEventPostingEnabled()

  Description copied from class: `LibraryObject`
  Checks if CORE audit event posting is enabled.

  Returns:
    true if CORE event posting is enabled

### isValidEventType

    protected boolean isValidEventType(AuditEvent event)
                                throws IfsException

  Description copied from class: `LibraryObject`
  Checks to see if the event type in the process of being posted on the target LibraryObject is consistent with the target.

  Parameters:
    `event` - the event being posted on this object
  Returns:
    true if the type is consistent; false otherwise
  Throws:
    `IfsException` - if the operation fails

### auditUpdated

    protected void auditUpdated(LibraryObjectDefinition lodef)
                         throws IfsException

  Description copied from class: `LibraryObject`
  Creates audit events for the update operation.

  Parameters:
    `lodef` - The update definition
  Throws:
    `IfsException` - if the operation fails.

### auditCreated

    protected void auditCreated(LibraryObjectDefinition lodef)
                         throws IfsException

  Description copied from class: `LibraryObject`
  Creates audit events for the create operation.

  Does not typically create the CREATED event, but instead creates any other events related to the create.

  Parameters:
    `lodef` - The create definition
  Throws:
    `IfsException` - if the operation fails.

### verifySystemUserAccess

    public void verifySystemUserAccess(LibrarySession session)
                                throws IfsException

  Description copied from class: `LibraryObject`
  Verifies that the specified session hasnot discovered the target object illegally.

  Parameters:
    `session` - the session context
  Throws:
    `IfsException` - if operation fails.

### getStringIdentifier

    public java.lang.String getStringIdentifier()

  Description copied from class: `LibraryObject`
  Returns this object's String ID.

  Returns:
    this object's String Identifier.
  (Unpublished)

### getId

    public java.lang.Long getId()
                         throws IfsException

  Description copied from class: `LibraryObject`
  Returns this object's ID (as a Long).

  Specified by:
    `getId` in interface `LibraryObjectInterface`
  Returns:
    this object's Long Id.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### getClassId

    public java.lang.Long getClassId()
                              throws IfsException

  Description copied from class: `LibraryObject`
  Return this object's Class Id.

  Specified by:
    `getClassId` in interface `LibraryObjectInterface`
  Returns:
    this object's Class Id.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getDefinition

    public LibraryObjectDefinition getDefinition()
                                          throws IfsException

  Description copied from class: `LibraryObject`
  Creates a LibraryObjectDefinition which represents this object. This method is generally used to allow a new object to be created based on this object. Because of that, attributes that should not be propigated (e.g., CREATEDATE) are not represented in the returned definition.

  Returns:
    a LibraryObjectDefinition which represents this object
  Throws:
    `IfsException` - if operation fails.
  (Published)

### isInstanceOf

    public boolean isInstanceOf(ClassObject clss)
                         throws IfsException

  Description copied from class: `LibraryObject`
  Determine if this is an instance of the specified ClassObject.

  Returns:
    true if this is an instance of the specified ClassObject.
  Throws:
    `IfsException` - if operation fails.
  (Published)

### isConnected

    protected boolean isConnected()
                           throws IfsException

  Description copied from class: `LibraryObject`
  Indicates the connection state.

  Returns:
    the connection state (true = connected)
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### verifyAdministrationMode

    protected void verifyAdministrationMode()
                                     throws IfsException

  Description copied from class: `LibraryObject`
  Verifies the administration mode for the session.

  Throws:
    `IfsException` - (AccessDeniedException) if not adminenabled
  (Unpublished)

### verifyConnected

    protected LibrarySession verifyConnected()
                                      throws IfsException

  Description copied from class: `LibraryObject`
  Returns the current LibrarySession if the session is connected; otherwise raise a "not connected" exception.

  Returns:
    the current LibrarySession
  Throws:
    `IfsException` - (ConnectionException) if not connected
  (Unpublished)

### verifyTargetObject

    protected void verifyTargetObject()
                               throws IfsException

  Description copied from class: `LibraryObject`
  Throw an exception if the object is not a valid persistent IFS object; e.g. if the object has been freed, or if it represents a non-IFS object such as a DS Role.

  Throws:
    `IfsException` - if target object is not persistent
  (Unpublished)

### getResourceString

    public java.lang.String getResourceString(java.lang.String key)
                                       throws IfsException

  Description copied from class: `LibraryObject`
  Gets the resource string for the specified key.

  The method looks-up the key in each extended resource bundle. If no extended resource bundle contains the key, the default resource bundle (LibraryResources) is used.

  Parameters:
    `key` - the resource bundle key
  Returns:
    the resource string
  Throws:
    `IfsException` - IFS-12001 if the operation fails
  (Unpublished)

### getResourceString

    public java.lang.String getResourceString(java.lang.String key,
                                              java.lang.Object[] params)
                                       throws IfsException

  Description copied from class: `LibraryObject`
  Gets the resource string for the specified key, and substitutes the specified parameters into that resource string.

  The method looks up the key using `getResourceString(key)`. Next, `java.text.MessageFormat` is used to substitute the parameters specified by `params` into the key's value. If a string element of `params` is delimited by brackets, i.e. "`{param}`", then that element is replaced with the value returned by `getResourceString("param")` before being passed to `MessageFormat`.

  Parameters:
    `key` - the resource bundle key
    `params` - an array of Objects to be substituted into the resource bundle message using using `java.text.MessageFormat`
  Returns:
    the formatted resource string
  Throws:
    `IfsException` - IFS-12006 if the operation fails
  (Unpublished)

### isTraced

    public final boolean isTraced(int channel,
                                  int level)
                           throws IfsException

  Description copied from class: `LibraryObject`
  Gets whether tracing is enabled for the specified channel and level.

  Specified by:
    `isTraced` in interface `Traceable`
  Parameters:
    `channel` - the channel number
    `level` - the level
  Returns:
    whether tracing is enabled
  Throws:
    `IfsException` - (IFS-11201) if the channel is invalid
  (Published)

### trace

    public final void trace(int channel,
                            int level,
                            java.lang.String payload)

  Description copied from class: `LibraryObject`
  Issues a trace request to the trace logger.

  Specified by:
    `trace` in interface `Traceable`
  Parameters:
    `channel` - the channel number
    `level` - the level
    `payload` - a string containing any additional information to be placed in the trace log
  (Published)

### getTraceLogger

    public final TraceLogger getTraceLogger()
                                     throws IfsException

  Description copied from class: `LibraryObject`
  Returns the trace logger of this object's session.

  Specified by:
    `getTraceLogger` in interface `Traceable`
  Returns:
    the trace logger
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### postEvent

    public final void postEvent(int eventType,
                                int eventStatus)
                         throws IfsException

  Description copied from class: `LibraryObject`
  Posts an event of the specified type and status.

  Parameters:
    `eventType` - the event type; must be one of the event type constants enumerated in IfsEvent
    `eventStatus` - the event status; must be one of the event status constants enumerated in IfsEvent
  Throws:
    `IfsException` - if the operation fails
  (Published)

### postEvent

    public final void postEvent(int eventType,
                                int eventSubtype,
                                int eventStatus,
                                long longPayload)
                         throws IfsException

  Description copied from class: `LibraryObject`
  Posts an event of the specified type, subtype, and status.

  Parameters:
    `eventType` - the event type; must be one of the event type constants enumerated in IfsEvent
    `eventSubtype` - the event subtype; the meaningful values are `eventType` variant
    `eventStatus` - the event status; must be one of the event status constants enumerated in IfsEvent
    `longPayload` - the long payload; the meaningful values are `eventType` variant
  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleEvent

    public void handleEvent(IfsEvent event)
                     throws IfsException

  Description copied from class: `LibraryObject`
  Handles the specified event.

  Specified by:
    `handleEvent` in interface `IfsEventHandler`
  Parameters:
    `event` - the event
  Throws:
    `IfsException` - if the operation fails
  (Published)

### handleAdminModeChange

    protected void handleAdminModeChange()
                                  throws IfsException

  Description copied from class: `LibraryObject`
  Handles an intra-session admin mode change event. This is used by subclasses to invalidate certain cached information that becomes invalid after an admin mode change. For example, Folder overrides this method to clear the item cache.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getSharedStateFactory

    public S_LibraryObjectDataSharedStateFactory getSharedStateFactory()

  Description copied from class: `LibraryObject`
  Returns a factory that can be used by bean-side callers to get shared state from a S_LibraryObjectData instance.

  Returns:
    a shared state factory
  (Published)

### constructLibraryObjectVector

    protected static java.util.Vector constructLibraryObjectVector(LibrarySession sess,
                                                                   java.util.Vector vector)
                                                            throws IfsException

  Description copied from class: `LibraryObject`
  Return LibraryObject Vector from a Vector of LibraryObject.

  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### constructLibraryObject

    protected static LibraryObject constructLibraryObject(LibrarySession sess,
                                                          S_LibraryObjectData data)
                                                   throws IfsException

  Throws:
    `IfsException`
  (Unpublished)

### vectorToLibraryObjectArray

    protected static LibraryObject[] vectorToLibraryObjectArray(java.util.Vector vector)

  (Unpublished)

### vectorLibraryObjectElement

    protected static LibraryObject vectorLibraryObjectElement(java.util.Vector vector,
                                                              int index)
                                                       throws java.lang.IndexOutOfBoundsException

  Throws:
    `java.lang.IndexOutOfBoundsException`
  (Unpublished)

### constructIdArray

    public static java.lang.Long[] constructIdArray(LibraryObject[] objs)
                                             throws IfsException

  Description copied from class: `LibraryObject`
  Construct an array of object IDs from an array of LibraryObjects.

  Parameters:
    `objs` - the array of objects
  Returns:
    the array of object IDs
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

### constructIdArray

    protected static java.lang.Long[] constructIdArray(java.util.Vector vector)
                                                throws IfsException

  Description copied from class: `LibraryObject`
  Construct an array of object IDs from a Vector of S_LibraryObjectData objects.

  Parameters:
    `vector` - the vector of S_LibraryObjectData
  Returns:
    the array of object IDs
  Throws:
    `IfsException` - if operation fails.
  (Unpublished)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD